<?php

require_once POST_MINER__PATH . 'TermVector.php';

/**
 * Model for interaction with the database. 
 * 
 * @todo this class should be reviewd as it contains some logic which should be in the Engine class.
 * 
 * @author Lukasz Kujawa <lukasz.f24@gmail.com>
 * @category PostMiner
 * 
 */
class PostMiner_TermMapper
{

    private $wpdb;

    
    public function __construct()
    {
        global $wpdb;
        
        $this->wpdb = $wpdb;
    }
    
    public function getTermVectorByPostId( $postId )
    {
        $sql = 'SELECT pt.id, ptr.weight
                FROM %spostminer_term_relationships ptr
                JOIN %spostminer_terms pt ON pt.id = ptr.postminer_term_id
                WHERE ptr.object_id = %d';
        
        $vector = array();
        
        foreach( $this->wpdb->get_results( sprintf( $sql, $this->wpdb->prefix, $this->wpdb->prefix, $postId ) ) as $row )
        {
            $vector[ $row->id ] = $row->weight;
        }

        return new PostMiner_TermVector( $vector );
    }
    
    public function getSimilarPostIds( PostMiner_TermVector $vector, $ignorePostId = false )
    {
        $_sql = 'SELECT object_id, (weight * %s) weight
                 FROM %spostminer_term_relationships
                 WHERE postminer_term_id = %d';

        $subSelect = array();
        foreach( $vector->getValues() as $termId => $weight )
        {
            $subSelect[] = sprintf( $_sql, $weight, $this->wpdb->prefix, $termId );
        }
        

        $sql = 'SELECT object_id, sum(weight) coorelation FROM( ';
        $sql.= implode( ' UNION ', $subSelect );
        $sql.= ') as u ';
        
        if( $ignorePostId )
        {
            $sql.= sprintf(' WHERE object_id != "%d" ', $ignorePostId );
        }
        
        $sql.= 'group by object_id order by coorelation desc limit 10';
        
        $posts = array();
        foreach( $this->wpdb->get_results( $sql ) as $row )
        {
            $posts[] = $row->object_id;
        }
                
        return $posts;
    }
}